program Siebener;
{ 7 Reihen harfenfrmig austeilen, verschiedene Farben zusammenlegen,  }
{ Stack zu 1, beliebig umdrehen }
{ 26.05.96:   Clone vom Neuner/Achter, modifiziert  }

{$M 8192,0,655360}
uses crt,dos,graph,drivers,intuit;

const titel='      Siebener-Patience, Klondike -   uja Vers.1.000         TP6.01';
      dx=56; dy=10; ysize=80; ox=-52; oy=20; sx=10*dx+ox; sy=oy+20;
      imafil='cards.ima'; nreihen=7; nablagen=4;
      pal:array[0..15,0..2] of word=(
         ( 0, 0, 0),( 0, 0,42),( 0,27, 0),(49,55,55),
         (42, 5, 0),( 0,24,23),(30, 0, 0),(44,39,35),
         (21,21,21),(21,21,63),(21,63,21),(21,63,63),
         (63,27,11),(59,52,51),(63,46, 0),(61,58,56));

var ok,ende,fertig     :boolean;
    cardmark,cardmask  :array[1..4] of Image;
    itext1,itext2      :array[1..10] of Intuitext;
    ibord1,ibord2      :Border;
    xy,xy2             :Koords;
    bgr1,bgr2,mask,leer:Image;
    igad               :array[1..24] of Gadget;
    g,mx,my,x,y,index,tindex,i,count:integer;
    ch                 :char;
    karte              :array[1..52] of Image;
    talon,cards        :array[0..104] of word;
    ablage             :array[1..nablagen] of word;
    reihen             :array[1..nreihen,0..39] of word;
    sichtbar           :array[1..nreihen,0..39] of boolean;
    temp:string;
{ ------------------------------------------------------------------------ }
{ === Karten - allgemeiner Teil ========================================== }

procedure getimages;
var i:integer;
    anz:word;
    fh:file;
begin
   assign(fh,imafil);
   reset(fh,1);
   for i:=1 to 52 do begin
      BlockRead(fh,karte[i],sizeof(image),anz);
      anz:=Imagesize(1,1,karte[i].width,karte[i].height);
      GetMem(karte[i].p_data,anz);
      BlockRead(fh,karte[i].p_data^,anz,anz);
   end;
   for i:=1 to 4 do begin
      BlockRead(fh,cardmask[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmask[i].width,cardmask[i].height);
      GetMem(cardmask[i].p_data,anz);
      BlockRead(fh,cardmask[i].p_data^,anz,anz);
      BlockRead(fh,cardmark[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmark[i].width,cardmark[i].height);
      GetMem(cardmark[i].p_data,anz);
      BlockRead(fh,cardmark[i].p_data^,anz,anz);
   end;
   BlockRead(fh,leer,sizeof(image),anz);
   anz:=Imagesize(1,1,leer.width,leer.height);
   GetMem(leer.p_data,anz);
   BlockRead(fh,leer.p_data^,anz,anz);
   BlockRead(fh,bgr1,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr1.width,bgr1.height);
   GetMem(bgr1.p_data,anz);
   BlockRead(fh,bgr1.p_data^,anz,anz);
   BlockRead(fh,bgr2,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr2.width,bgr2.height);
   GetMem(bgr2.p_data,anz);
   BlockRead(fh,bgr2.p_data^,anz,anz);
   close(fh);
end;

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,i);
end;
end;

{ ------------------------------------------------------------------------ }

procedure intuikram;
var i,k:integer;
begin
   for i:=1 to 10 do with itext1[i] do begin
      x:=8; y:=5; fpen:=15; bpen:=7; p_nexttext:=addr(itext2[i]);
      if i>3  then x:=4;
      case i of
      1: itext:=' Neu';
      2: itext:=' Quit';
      3: itext:='Talon';
      4: itext:='T.Wahl';
      5: itext:='Stack';
      6: itext:='Hilfe';

      7: itext:='1 Kar.';
      8: itext:='3 dreh';
      9: itext:='3 Kar.';
      10: itext:='x dreh';
      end;
   end;
   for i:=1 to 10 do with itext2[i] do begin
      x:=pred(itext1[i].x); y:=itext1[i].y; fpen:=0; bpen:=itext1[i].bpen;
      itext:=itext1[i].itext; p_nexttext:=nil;
   end;

   xy[0]:=0;  xy[1]:=0; xy[2]:=56;  xy[3]:=0; xy[4]:=56;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   xy2[0]:=0;  xy2[1]:=0; xy2[2]:=112; xy2[3]:=0; xy2[4]:=112;
   xy2[5]:=15; xy2[6]:=0; xy2[7]:=15;  xy2[8]:=0; xy2[9]:=0;
   with ibord1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

{ neu, quit: }
   for i:=1 to 2 do with igad[i] do begin
      id:=i;
      x:=sx+pred(i)*dx;
      y:=460;
      width:=dx;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;

{ Talon, Stack, Hilfe, 2  Varianten: }
  k:=3;
  for i:=1  to 5 do with igad[k] do begin
      id:=k;
      x:=sx+dx;
      y:=oy+4+(k+3)*16;
      width:=dx;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[k]);
      p_hiintuitext:=p_lointuitext;
      if k>5 then p_hiintuitext:=addr(itext1[k+2]); 
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(k)]);
      inc(k);
   end;

   { Ablagen: }
   for i:=1 to nablagen do with igad[k] do begin
      id:=k;
      if i<5 then x:=sx else x:=sx+dx;
      if i<5 then y:=i*ysize+sy else y:=(i-4)*ysize+sy;
      width:=dx;
      height:=ysize;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(k)]);
      inc(k);
   end;

{ Reihen: }
   for i:=1 to nreihen do with igad[k] do begin
      id:=k;
      x:=i*dx+ox;
      y:=oy+dy;
      width:=dx;
      height:=480-y;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(k)]);
      inc(k);
   end;

  with igad[k] do begin
      id:=k;
      x:=sx+dx;
      y:=oy+dy+4;
      width:=dx;
      height:=ysize;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(k)]);
      inc(k);
   end;
  with igad[k] do begin
      id:=k;
      x:=sx-dx;
      y:=oy+dy+4;
      width:=dx;
      height:=ysize;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;

end;

{ ------------------------------------------------------------------------ }

procedure darken;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,i);
end;

procedure buildscreen(reihen,stacks:word);
var i:integer;
    b1,b2:Border;
    xy   :Koords;
    temp:string;
begin
{ Background: }
   xy[0]:=0;  xy[1]:=0; xy[2]:=631; xy[3]:=0; xy[4]:=631;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   with b1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(b2);
   end;
   with b2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;
   rectfill(0,0,639,479,5);
   rectfill(2,2,635,17,7);
   DrawBorder(2,2,addr(b1));
   setcolor(15); outtextxy(33,7,titel);
   setcolor(0);  outtextxy(32,7,titel);
   putimage(510,5,cardmask[1].p_data^,andput);
   putimage(511,5,cardmark[1].p_data^,orput);
   for i:=2 to 4 do begin
      putimage(i*16-20,5,cardmask[i].p_data^,andput);
      putimage(i*16-19,5,cardmark[i].p_data^,orput);
   end;
{ Talon: }
   putimage(sx-dx,oy+dy+4,bgr1.p_data^,normalput);
   putimage(sx,oy+dy+4,bgr2.p_data^,normalput);
   putimage(sx+16,oy+dy+4,bgr2.p_data^,normalput);
   putimage(sx+32,oy+dy+4,bgr2.p_data^,normalput);
{ Ablagen: }
   for i:=1 to 4 do begin
      putimage(sx,sy+i*ysize,bgr2.p_data^,normalput);
      putimage(sx+23,sy+i*ysize+36,cardmask[i].p_data^,andput);
      putimage(sx+24,sy+i*ysize+36,cardmark[i].p_data^,orput);
      if stacks>4 then begin
         putimage(sx+dx,sy+i*ysize,bgr2.p_data^,normalput);
         putimage(sx+dx+23,sy+i*ysize+36,cardmask[i].p_data^,andput);
         putimage(sx+dx+24,sy+i*ysize+36,cardmark[i].p_data^,orput);
      end;
   end;
   setcolor(15);
   for i:=1 to reihen do begin
      temp:=chr(i+48);
      outtextxy(i*dx+ox+25,22,temp);
   end;
   setcolor(0);
   for i:=1 to reihen do begin
      temp:=chr(i+48);
      outtextxy(i*dx+ox+24,22,temp);
   end;
{ Markierungen fr keyboard-Mode: }
  setcolor(15);
   for i:=1 to 4 do begin
      temp:=chr(i+64);
      outtextxy(sx+9,oy+i*ysize+dy+16,temp);
      if stacks>4 then begin
         temp:=chr(i+68);
         outtextxy(sx+9,oy+i*ysize+dy+16,temp);
      end;
   end;
   outtextxy(sx+dx+36,oy+48,'T');
   setcolor(0);
   for i:=1 to 4 do begin
      temp:=chr(i+64);
      outtextxy(sx+8,oy+dy+i*ysize+16,temp);
      if stacks>4 then begin
         temp:=chr(i+68);
         outtextxy(sx+8+dx,oy+i*ysize+dy+16,temp);
      end;
   end;
   outtextxy(sx+dx+35,oy+48,'T');
   RefreshGadgets(addr(igad[1]));
end;

procedure mischen;
var i,j,k:integer;
begin
   for i:=1 to nablagen do ablage[i]:=0;
   for i:=1 to nreihen do reihen[i,0]:=0;
   for i:=1 to 52 do cards[i]:=i;
   if cards[0]>52 then for i:=1 to 52 do cards[i+52]:=i;
   randomize;
   for i:=1 to cards[0] do begin
      j:=succ(random(1000) mod cards[0]);
      k:=cards[i];
      cards[i]:=cards[j];
      cards[j]:=k;
   end;
   talon:=cards;
end;

procedure showrest(nr:integer);
var temp:string;
begin
   str(nr:3,temp);
   temp:='Rest:'+temp+' Karten';
   rectfill(sx-12,oy,sx+2*dx-1,oy+dy,1);
   setcolor(0); outtextxy(sx-10,oy+2,temp);
   setcolor(0); outtextxy(sx-8,oy+2,temp);
   setcolor(9);  outtextxy(sx-9,oy+2,temp);
end;



procedure auslegen(nrow:word; offen:boolean);
var i,j,k:integer;
    temp:string;
begin
   for i:=1 to nrow do if talon[0]>0 then begin
      inc(reihen[i,0]);
      k:=reihen[i,0];
      reihen[i,k]:=talon[talon[0]];
      sichtbar[i,k]:=offen;
      dec(talon[0]);
      if offen then
      putimage(i*dx+ox,k*dy+oy,karte[reihen[i,k]].p_data^,normalput)
      else
      putimage(i*dx+ox,k*dy+oy,bgr1.p_data^,normalput);
   end;
   showrest(talon[0]);
end;

procedure talonlegen(var tindex:integer);
var i,e:integer;
begin
   if talon[0]>0 then begin
      inc(tindex);
      if tindex>talon[0] then begin
         inc(count);
         tindex:=0;
         putimage(dx+sx,oy+dy+4,bgr2.p_data^,normalput);
         setcolor(15); outtextxy(sx+dx+26,oy+48,'M');
         setcolor(0); outtextxy(sx+dx+25,oy+48,'M');
      end else putimage(dx+sx,oy+dy+4,karte[talon[tindex]].p_data^,normalput);
   end else begin { Reparaturarbeiten }
      rectfill(sx,oy+dy+4,sx+2*dx,oy+dy+4+ysize,5);
      talon[0]:=0;
   end;
end;

procedure talonupdaten(var tindex:integer); { nimmt Karte aus Talon }
var i,j:integer;
begin
   if talon[0]>0 then begin
      dec(talon[0]);
      if tindex<=talon[0] then for i:=tindex to talon[0] do talon[i]:=talon[succ(i)];
      dec(tindex);
      if tindex<1 then begin
         putimage(dx+sx,oy+dy+4,bgr2.p_data^,normalput);
         setcolor(15); outtextxy(sx+dx+26,oy+48,'T');
         setcolor(0); outtextxy(sx+dx+25,oy+48,'T');
      end else putimage(dx+sx,oy+dy+4,karte[talon[tindex]].p_data^,normalput);
      showrest(talon[0]);
   end;
   if talon[0]=0 then rectfill(sx,oy+dy+4,sx+2*dx,oy+dy+4+ysize,5);
end;

procedure markiere(n,p:integer);
var x,y,z:integer;
begin
   if n=19 then begin { Talon }
      putimage(dx+sx,oy+dy+4,bgr2.p_data^,andput);
   end else if n<11 then begin { Reihen }
      x:=n*dx+ox;
      y:=p*dy+oy;
      putimage(x,y,leer.p_data^,andput);
   end else begin
      z:=n-10;
      x:=sx;
      if z>4 then begin x:=x+dx; z:=z-4; end;
      y:=sy+ysize*z;
      putimage(x,y,bgr2.p_data^,andput);
   end;
end;

procedure zeichnereihe(n:integer);
var i:integer;
begin
rectfill(ox+n*dx,oy+dy,pred(ox+succ(n)*dx),479,5);
if reihen[n,0]>0 then for i:=1 to reihen[n,0] do begin
   if i=reihen[n,0] then sichtbar[n,i]:=true;
   if sichtbar[n,i] then putimage(ox+n*dx,oy+i*dy,karte[reihen[n,i]].p_data^,normalput)
                    else putimage(ox+n*dx,oy+i*dy,bgr1.p_data^,normalput);
end else putimage(ox+n*dx,oy+dy,bgr2.p_data^,andput);
end;

procedure demarkiere(n,p:integer);
var a,x,y,z:integer;
begin
   if n=19 then begin { Talon demarkieren }
      if tindex>0 then
      putimage(sx+dx,oy+dy+4,karte[talon[tindex]].p_data^,normalput)
      else putimage(sx+dx,oy+dy+4,bgr2.p_data^,normalput)
   end else if n<11 then zeichnereihe(n) else begin
      z:=n-10;    { Stack }
      a:=z;
      x:=sx; if z>4 then begin x:=x+dx; z:=z-4; end;
      y:=sy+z*ysize;
      if ablage[a]=0 then begin
         putimage(x,y,bgr2.p_data^,normalput);
         putimage(x+19,y+36,cardmask[z].p_data^,andput);
         putimage(x+20,y+36,cardmark[z].p_data^,orput);
      end else begin
         z:=pred(z)*13+ablage[a];
         putimage(x,y,karte[z].p_data^,normalput);
      end;
   end;
end;

{ ======================================================================== }
procedure achter_2a;
var j:integer;
begin
   for j:=1 to 6 do auslegen(j,false);
   auslegen(7,true);
   tindex:=0;
   count:=0;
   i:=0;
   y:=0;
end;

procedure checkablage(nr,na:word; var ok:boolean);
var e1,e2,f1,f2,g1,g2:integer;
begin
   ok:=(nr>0) and (nr<11);
   ok:=ok or (nr=19);
   ok:=ok and (ablage[na]<13);
   if ok then begin
      e1:=succ(ablage[na]);
      if nr<19 then e2:=reihen[nr,reihen[nr,0]] else e2:=talon[tindex];
      f1:=e1 mod 13;
      f2:=e2 mod 13;
      g1:=pred(e2) div 13;
      g2:=pred(na) mod 4;
      ok:=(f1=f2) and (g1=g2);
   end;
end;

function sequenz(nr1,np1,nr2,np2:word):boolean;
var e1,e2:word;
    seq  :boolean;
begin
   seq:=false;
{   if sichtbar[nr1,np1] then begin      gleiche  Farben
      e1:=pred(reihen[nr1,np1]);
      e2:=pred(reihen[nr2,np2]);
      seq:=(e1 div 13)=(e2 div 13);
   end; }
   if sichtbar[nr1,np1] then begin    { wechselnde  Farben  }
      e1:=pred(reihen[nr1,np1]);
      e2:=pred(reihen[nr2,np2]);
      seq:=(e1 in [0..25]) and (e2 in [26..51]);
      seq:=seq or (e2 in [0..25]) and (e1 in [26..51]);
   end;
   sequenz:=seq and ((reihen[nr2,np2] mod 13)=(succ(reihen[nr1,np1]) mod 13));
end;

procedure checkreihen(n1,n2,y:word; ok:boolean);
{ an die unterste Karte von der Reihe n2 die passende von n1 anlegen }
var e,i,k1,k2      :integer;
    weiter,gefunden:boolean;
begin
   k2:=reihen[n2,0];
   if y>0 then gefunden:=sequenz(n1,y,n2,k2);
   if gefunden then k1:=y else begin
      k1:=reihen[n1,0];
      weiter:=true;
      while (k1>0) and weiter do begin
         gefunden:=sequenz(n1,k1,n2,k2);
         weiter:=not gefunden;
         if weiter then if sequenz(n1,k1,n1,k1-1) then dec(k1) else weiter:=false;
      end;
   end;
   if gefunden then begin
      for i:=k1 to reihen[n1,0] do begin
         inc(reihen[n2,0]);
         sichtbar[n2,reihen[n2,0]]:=true;
         reihen[n2,reihen[n2,0]]:=reihen[n1,i];
         dec(reihen[n1,0]);
      end;
      zeichnereihe(n1);
      zeichnereihe(n2);
   end;
end;

procedure reihehoch(n1,n2,y:word; var ok:boolean);
{ Reihe hochlegen von nach n2 }
var i,k1,k2:integer;
    weiter :boolean;
begin
   ok:=true;
   if y>0 then k1:=y else begin
      weiter:=true;
      k1:=reihen[n1,0];
      while weiter and (k1>1) do begin
         weiter:=sequenz(n1,k1,n1,k1-1);
         weiter:=weiter and sichtbar[n1,k1-1];
         if weiter then dec(k1);
      end;
   end;
   for i:=k1 to reihen[n1,0] do begin
      inc(reihen[n2,0]);
      sichtbar[n2,reihen[n2,0]]:=true;
      reihen[n2,reihen[n2,0]]:=reihen[n1,i];
      dec(reihen[n1,0]);
   end;
   zeichnereihe(n1);
   zeichnereihe(n2);
end;

procedure aufraeumen(reihe,stacks:word);
var i,j,k    :integer;
    weiter,ok:boolean;
begin
   weiter:=true;
   while weiter do begin
      weiter:=false;
      for i:=1 to reihe do if reihen[i,0]>0 then begin
         j:=0;
         ok:=false;
         for j:=1 to stacks do begin
            checkablage(i,j,ok);
            if ok then begin
               dec(reihen[i,0]);
               zeichnereihe(i);
               inc(ablage[j]);
               demarkiere(j+10,y);
               weiter:=true;
            end;
         end;
      end;
      if tindex>0 then for j:=1 to stacks do begin
         checkablage(19,j,ok);
         if ok then begin
            talonupdaten(tindex);
            inc(ablage[j]);
            demarkiere(j+10,y);
            weiter:=true;
         end;
      end;
   end;
end;

procedure fanfare;
var i,x,y,a,a1,a2:integer;
    r1,r2  :real;
    temp   :string;
begin
randomize;
i:=52*50-13;
a:=0;
while (i>0) and not keypressed do begin
   dec(i);
   r1:=i*0.15;
   r2:=i*0.10;
   x:=trunc(r1*sin(r2))+320;
   y:=trunc(r2*cos(r1))+240;
   a:=a+1; if a>52 then a:=a-52;
   putimage(x,y,karte[a].p_data^,normalput);
   delay(5);
end;
x:=16; y:=460;
rectfill(x-8,y-8,x+480,y+16,0);
rectfill(x-7,y-7,x+479,y+15,15);
rectfill(x-6,y-6,x+478,y+14,7);
temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
setcolor(15); outtextxy(x,y,temp);
setcolor(0);  outtextxy(pred(x),y,temp);
ch:=readkey; if ch=#0 then ch:=readkey;
ende:=ch=#27;
if not ende then begin
   buildscreen(7,4);
   mischen;
   achter_2a;
   for i:=1 to 19 do if not (i in [8,9,10,15..18]) then demarkiere(i,0);
end;
end;

procedure helpscreen;
const ofy=12;
var c,i,x1,x2,y1,y2:integer;
    temp          :string;
begin
x1:=32; y1:=48; x2:=x1+560; y2:=y1+320;
rectfill(x1,y1,x2,y2,0);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,15);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,7);
putimage(574,350,cardmask[1].p_data^,andput);
putimage(575,350,cardmark[1].p_data^,orput);

x1:=x1+8;
for i:=1 to 21 do begin
   case i of
   1                  : y1:=y1+8;
   2,7,9              : y1:=y1+16;
   3..6,8,10,12..16,19,20: y1:=y1+ofy;
   11                 : y1:=y1+24;
   17,18              : y1:=y1+10;
   21                 : y1:=y1+40;
   end;
   case i of
   1,9..16,19..21: c:=0;
   2..6          : c:=1;
   7..8          : c:=6;
   17,18         : c:=8;
   end;

   case i of
   1: temp:='A c h t e r - P a t i e n c e (Voll-Version):';
   2: temp:='Ziel ist es, alle Karten auf die Stacks zu sammeln, wobei die Farben';
   3: temp:='gleich sein sollten und die Werte ansteigend (z.B. KAs,K2,K3,K4...).';
   4: temp:='Die Spalten werden mit absteigenden Werten gebildet, wobei die Far- ';
   5: temp:='ben (Herz, Kreuz, ...) gleich sein mssen (Sequenz). Ist eine Spalte';
   6: temp:='leer, so kann eine freie Sequenz an deren Stelle gelegt werden.     ';
   7: temp:='Zu Beginn werden 3 Reihen ausgelegt. Vom Talon oder von anderen Rei-';
   8: temp:='hen her kann man Karten anlegen. Der Talon darf 3x umgedreht werden.';
   9: temp:='Zunchst mu man die zu verschiebende Karte/Sequenz whlen, dann das';
   10: temp:='Ziel. Bei gltiger Wahl wird der Zug durchgefhrt.';
   11: temp:='Steuerung              mit Keyboard:             mit Maus:';
   12: temp:='neues Spiel           :  [N]                     [  Neu ]';
   13: temp:='Ende                  :  [Q],[esc]               [ Quit ]';
   14: temp:='Talon umdrehen        :  [T]                     [ Talon]';
   15: temp:='auf dem Stack ablegen :  [S]                     [ Stack]';
   16: temp:='Karte in Reihen whlen:  [1] bis [8]             Karte anklicken';
   17: temp:='die passende Karte wird vom Spiel gesucht';
   18: temp:='die zu verschiebende Karte wird markiert';
   19: temp:='Karte vom Stack whlen:  [A] bis [H]             Karte anklicken';
   20: temp:='Talonkarte whlen     :  [M]                     Karte anklicken';
   21: temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
   end;
   setcolor(15); outtextxy(x1,y1,temp);
   setcolor(c);  outtextxy(pred(x1),y1,temp);
end;

ch:=readkey; if ch=#0 then ch:=readkey;
ende:=ch=#27;
if not ende then begin
   buildscreen(7,4);
   for i:=1 to 19 do if not (i in [8,9,10,15..18]) then demarkiere(i,0);
end;
end;


{ ======================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      darken;
      getimages;
      intuikram;
      buildscreen(7,4);
      cards[0]:=52;
      lighten;
      mischen;
      achter_2a;
      ende:=false;
      while not ende do begin
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         if keypressed then begin
            ch:=readkey;
            case ch of
            #0                : begin
                                   ch:=readkey;
                                   if ch=#59 then helpscreen;
                                end;
            #27,'Q','q'       : g:=2;
            'S','s'           : g:=5;
            'N','n'           : g:=1;
            'T','t'           : g:=3;
            'W','w'           : g:=4;
            '1'..'7'          : begin g:=ord(ch)-37; my:=oy+dy; end; {12-20}
            'A'..'D','a'..'d' : g:=ord(upcase(ch))-57;               { 8-11}
            end;
         end;
         if g=19 then g:=4;
         if g=20 then g:=3;
         case g of
         1: begin
               buildscreen(nreihen,nablagen);
               mischen;
               achter_2a;
            end;
         2: ende:=true;
         3: if count<3 then talonlegen(tindex) else begin
               rectfill(78,78,542,262,0);
               rectfill(79,79,541,261,15);
               rectfill(80,80,540,260,4);
               setcolor(15); outtextxy(128,128,' -   G a m e   o v e r ! -');
               setcolor(0);  outtextxy(127,128,' -   G a m e   o v e r ! -');
               setcolor(15); outtextxy(192,160,' -   G a m e   o v e r ! -');
               setcolor(0);  outtextxy(191,160,' -   G a m e   o v e r ! -');
               setcolor(15); outtextxy(240,192,' -   G a m e   o v e r ! -');
               setcolor(0);  outtextxy(239,192,' -   G a m e   o v e r ! -');
            end;
          4: { Talon markieren: } begin
                  if i>0 then demarkiere(i,0);
                  i:=19; markiere(i,0);
               end;
          5: begin
               if i>0 then begin
                  demarkiere(i,y);
                  y:=0;
                  i:=0;
               end;
               aufraeumen(7,4);
             end;
         6: ;  {Hilfe}
         7: ; { Opt 1/3 Karten umlegen }
         8..11: if i=0 then begin  { Ablagen }
                   i:=g+3;
                   if ablage[i-10]>0 then markiere(i,y) else i:=0;
                end else begin
                   checkablage(i,g-7,ok);
                   if ok then begin
                      if i=20 then begin
                         talonupdaten(tindex);
                      end else if i=19 then  begin
                          talonupdaten(tindex);
                           demarkiere(g+3,y);
                      end else begin
                         dec(reihen[i,0]);
                         zeichnereihe(i);
                      end;
                      inc(ablage[g-7]);
                      demarkiere(g+3,y);
                      i:=0;
                   end else begin
                      demarkiere(i,y);
                      i:=0;
                   end;
                end;
         12..18: if i=0 then begin  { Reihen }
                    y:=(my-oy) div dy;
                    i:=g-11;
                    if reihen[i,0]>0 then begin
                       if y>reihen[i,0] then y:=reihen[i,0];
                       my:=0;
                       if y<reihen[i,0] then for x:=reihen[i,0] downto y+1 do begin
                          if not sequenz(i,x,i,pred(x)) then if my=0 then my:=x;
                       end;
                       if my>0 then y:=my;
                       markiere(i,y);
                    end;
                 end else begin  { umschichten }
                    if i=19 then begin { Talon auf Reihe }
                       reihen[g-11,succ(reihen[g-11,0])]:=talon[tindex];
                       sichtbar[g-11,succ(reihen[g-11,0])]:=true;
                       if reihen[g-11,0]=0 then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             talonupdaten(tindex);
                       end else if sequenz(g-11,succ(reihen[g-11,0]),g-11,reihen[g-11,0]) then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             talonupdaten(tindex);
                       end;
                    end else if i<11 then begin
                       if i<>(g-11) then begin
                          if reihen[g-11,0]=0 then reihehoch(i,g-11,y,ok)
                                              else checkreihen(i,g-11,y,ok);
                          if not ok then demarkiere(i,y);
                       end;
                    end else begin { Ablage auf Reihe }
                       if ablage[i-10]>0 then begin
                          reihen[g-11,succ(reihen[g-11,0])]:=ablage[i-10]+((i-11) mod 4)*13;
                          sichtbar[g-11,succ(reihen[g-11,0])]:=true;
                          if reihen[g-11,0]=0 then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             dec(ablage[i-10]);
                          end else if sequenz(g-11,succ(reihen[g-11,0]),g-11,reihen[g-11,0]) then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             dec(ablage[i-10]);
                          end;
                       end;
                    end;
                    if i>0 then demarkiere(i,y);
                    i:=0;
                 end;

         21: begin { Reihe auslegen }
               if i>0 then begin demarkiere(i,y); i:=0; y:=0; end;
               inc(index);
               auslegen(8,true);
             end;
        23: if tindex>0 then begin
                if i>0 then demarkiere(i,y);
                i:=19;
                markiere(i,y);
             end;
         end;
         fertig:=true;
         for mx:=1 to 7 do if reihen[mx,0]>0 then fertig:=false;
         if fertig then begin i:=0; fanfare; end;
      end;
   end;
   textmode(3);
end.

